# NMAKE makefile for Windows NT

!include <ntwin32.mak>

UTILFLAGS=-DUTIL $(CFLAGS)
DEF=-DMSC -DNO_ASM -DEXPORT -DMSDOS
#     If you use lzexe as recommended, remove /e from LDFLAGS
AS=masm386
#     For MSC 6.0, use: AS=ml 
ASFLAGS=-ml -t

# ------------- Common declarations:
STRIP=rem
# variables

OBJZ = zip.obj zipfile.obj zipup.obj fileio.obj util.obj tempf.obj shrink.obj\
 globals.obj
OBJI = implode.obj im_lmat.obj im_ctree.obj im_bits.obj

#OBJN = zipnote.obj zipfile_.obj zipup_.obj fileio_.obj globals.obj
OBJS = zipsplit.obj zipfile_.obj zipup_.obj fileio_.obj globals.obj

#zips:   zip.exe zipnote.exe zipsplit.exe ship.exe

all: zip.exe
    @echo Building ZIP for Windows NT

zip.obj:        zip.h ziperr.h tailor.h revision.h zip.c
    $(cc) $(cflags) $(DEF) $(cvars) $*.c
    $(cvtobj) $*.obj

zipfile.obj:    zip.h ziperr.h tailor.h zipfile.c
    $(cc) $(cflags) $(DEF) $(cvars) zipfile.c
    $(cvtobj) zipfile.obj

zipup.obj:      zip.h ziperr.h tailor.h revision.h zipup.c
    $(cc) $(cflags) $(DEF) $(cvars) $*.c
    $(cvtobj) $*.obj

fileio.obj:     zip.h ziperr.h tailor.h fileio.c
    $(cc) $(cflags) $(DEF) $(cvars) $*.c
    $(cvtobj) $*.obj

util.obj:       zip.h ziperr.h tailor.h util.c
    $(cc) $(cflags) $(DEF) $(cvars) $*.c
    $(cvtobj) $*.obj

tempf.obj:      tempf.h tailor.h tempf.c
    $(cc) $(cflags) $(DEF) $(cvars) $*.c
    $(cvtobj) $*.obj

shrink.obj:     zip.h ziperr.h tempf.h tailor.h shrink.c
    $(cc) $(cflags) $(DEF) $(cvars) $*.c
    $(cvtobj) $*.obj

globals.obj:    zip.h ziperr.h tailor.h globals.c
    $(cc) $(cflags) $(DEF) $(cvars) $*.c
    $(cvtobj) $*.obj

#zipnote.obj:    zip.h ziperr.h tailor.h revision.h zipnote.c
#    $(cc) $(cflags) $(DEF) $(cvars) $*.c
#    $(cvtobj) $*.obj

# MSC 5.1 dies on zipsplit with -Ox
zipsplit.obj:   zipsplit.c zip.h ziperr.h tailor.h revision.h
    $(cc) $(cflags) $(DEF) -DEXPORT $(cvars) $*.c
    $(cvtobj) $*.obj

implode.obj:    implode.h crypt.h ziperr.h tempf.h tailor.h implode.c
    $(cc) $(cflags) $(DEF) $(cvars) $*.c
    $(cvtobj) $*.obj

im_lmat.obj:    implode.h crypt.h ziperr.h tempf.h tailor.h im_lmat.c
    $(cc) $(cflags) $(DEF) $(cvars) $*.c
    $(cvtobj) $*.obj

im_lm.obj:      im_lm.asm
#       $(AS) $(ASFLAGS) im_lm;
	masm386 im_lm;
	$(cvtobj) im_lm.obj

im_ctree.obj:   implode.h crypt.h ziperr.h tempf.h tailor.h im_ctree.c
    $(cc) $(cflags) $(DEF) $(cvars) $*.c
    $(cvtobj) $*.obj

im_bits.obj:    implode.h crypt.h ziperr.h tempf.h tailor.h im_bits.c
    $(cc) $(cflags) $(DEF) $(cvars) $*.c
    $(cvtobj) $*.obj

zipfile_.obj:   zipfile.c zip.h
    $(cc) $(cflags) $(DEF) $*UTILFLAGS) $(cvars) zipfile.c
    $(cvtobj) zipfile.obj

zipup_.obj:     zipup.c zip.h
    $(cc) $(cflags) $(DEF) $(UTILFLAGS) $(cvars) zipup.c
    $(cvtobj) zipup.obj

fileio_.obj:    fileio.c zip.h
    $(cc) $(cflags) $(DEF) $(UTILFLAGS) $(cvars) fileio.c
    $(cvtobj) fileio_.obj

# link zip.exe
zip.exe: $(OBJZ) $(OBJI)
    $(link) $(conflags) -out:zip.exe $(OBJZ) $(OBJI) setargv.obj $(conlibs)
